%define anolis_release 1

%global debug_package   %{nil}
%global selinux_type targeted
%global module_names container

%global _format() export %1=""; for x in %{module_names}; do %1+=%2; %1+=" "; done;
%global selinux_policyver 3.13.1-220

Name:    container-selinux
Epoch:   2
Version: 2.210.0
Release: %{anolis_release}%{dist}
Summary: SELinux policies for container runtimes
License: GPLv2
URL:     https://github.com/containers/container-selinux
Source0: https://github.com/containers/container-selinux/archive/refs/tags/v%{version}.tar.gz
BuildArch: noarch

BuildRequires: make pkgconfig(systemd)
BuildRequires: selinux-policy >= %selinux_policyver
BuildRequires: selinux-policy-devel >= %selinux_policyver

Requires: selinux-policy >= %selinux_policyver
Requires(post): policycoreutils sed selinux-policy-base >= %selinux_policyver
Requires(post): libselinux-utils selinux-policy-targeted >= %selinux_policyver

Obsoletes: %{name} <= %{?epoch:%{epoch}:}1.12.5-13
Obsoletes: docker-selinux <= %{?epoch:%{epoch}:}1.12.4-28
Provides: docker-selinux = %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: udica < 0.2.6-1
Conflicts: k3s-selinux <= 0.4-1

%description
SELinux policy files for Container Runtimes

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1
sed -i '/user_namespace/d' container.te

%build
%make_build

%install
# install policy modules
%_format MODULES $x.pp.bz2
mkdir -p %{buildroot}%{_datadir}/selinux/packages
install -m 0644 $MODULES %{buildroot}%{_datadir}/selinux/packages
mkdir -p %{buildroot}%{_datadir}/selinux/devel/include/services
install -p -m 644 container.if %{buildroot}%{_datadir}/selinux/devel/include/services
mkdir -p %{buildroot}/%{_datadir}/containers/selinux
install -m 644 container_contexts %{buildroot}/%{_datadir}/containers/selinux/contexts
mkdir -p %{buildroot}%{_datadir}/udica/templates
install -m 0644 udica-templates/*.cil %{buildroot}%{_datadir}/udica/templates

%check

%pre
%selinux_relabel_pre -s %{selinux_type}

%post
if [ $1 -eq 1 ]; then
   %{_sbindir}/setsebool -P -N virt_use_nfs=1 virt_sandbox_use_all_caps=1
fi
%_format MODULES %{_datadir}/selinux/packages/$x.pp.bz2
for file in container docker gear; do
   if [ $file == "container" ]; then
      %{_sbindir}/semodule -n -s %{selinux_type} -r $file 2> /dev/null
   else
      %{_sbindir}/semodule -n -s %{selinux_type} -d $file 2> /dev/null
   fi
done
%selinux_modules_install -s %{selinux_type} $MODULES
. %{_sysconfdir}/selinux/config
sed -e "\|container_file_t|h; \${x;s|container_file_t||;{g;t};a\\" -e "container_file_t" -e "}" -i /etc/selinux/%{selinux_type}/contexts/customizable_types 
matchpathcon -qV %{_sharedstatedir}/containers || restorecon -R %{_sharedstatedir}/containers &> /dev/null || :

%postun
if [ $1 -eq 0 ]; then
   %selinux_modules_uninstall -s %{selinux_type} %{module_names} docker
fi

%posttrans
%selinux_relabel_post -s %{selinux_type}

%files
%dir %{_datadir}/containers/selinux
%{_datadir}/containers/selinux/contexts
%dir %{_datadir}/udica/templates/
%{_datadir}/udica/templates/*
%{_datadir}/selinux/*

%triggerpostun -- container-selinux < 2:2.162.1-3
if %{_sbindir}/selinuxenabled ; then
    echo "Fixing Rootless SELinux labels in homedir"
    %{_sbindir}/restorecon -R /home/*/.local/share/containers/storage/overlay*  2> /dev/null
fi

%files doc
%doc CODE-OF-CONDUCT.md README.md SECURITY.md

%changelog 
* Mon Apr 10 2023 yuanhui <yuanhui@linux.alibaba.com> - 2.210.0-1
- Optimize the spec file
- Update to v2.210.0

* Tue Feb 28 2023 yuanhui <yuanhui@linux.alibaba.com> - 2.201.0-1
- update to v2.201.0

* Wed Aug 31 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.189.0-1
- update containers-selinux to 2.189.0

* Fri Mar 11 2022 Zhongling He <zhonglingh@linux.alibaba.com> 2.178.0-1
- Init package from upstream v2.178.0
